#####################################################################################
#																					#
#		 				Mongwell International Crosswords 							#
#																					#
#####################################################################################

use strict;

#####################################################################################
#
#						Configuration Variables

my %config;

# Edit these variables in order to set up International Crossword on your system.
# Include the trailing slash for all directories.

# This is the path to your CGI directory.  In most cases it can be left blank.
#
$config{'cgipath'} = "";


# This is your default alphabet file
#
$config{'alphabet'} = "english.abt";


# This is the path to your crosswords data directory, usually right under your HTML
# root directory. It can be absolute or relative from your cgi directory.
# 
$config{'docpath'} = "../../crosswords/";


# Set this password to anything you like.  Leave it blank if you don't want to use
# an administrator password.
#
$config{'password'} = "";


# This is the path to the template file you are going to use.  Leave it blank if you're not
# using a template file.  A template file is just a regular HTML file that you've edited by
# putting the marker @insert on a blank line.  The place where you put @insert will be where
# the program inserts the crossword.
#
$config{'template'} = "../../crosswords/template/template.htm";

#
#####################################################################################

#####################################################################################
#
#  This program was written by Gurmukh Mongia.  You are free to use and distribute
#  it as needed under the terms of the GNU General Public License (included).  
#
#  You may modify this program as you see fit, however you may not remove this
#  message or modify it in any way.
#
#  If you make modifications to this program, please make not of them in the following
#  log:
#
#  DATE			MODIFIER			MODIFICATION
#  ---------------------------------------------
#  05/30/04		Gurmukh Mongia		Completed version 1.0 (Greek Edition)
#  06/01/04		Gurmukh Mongia		Added password, template, and erase ability.
#									New version 1.3
#  10/25/05		Gurmukh Mongia		Added the ability to customize language data
#									files to any language, also fixed a few bugs.
#									New version 1.5	
#
# 

########################################
#
#  Do not edit after this point unless
#  you know what you're doing
#

open (ALPHABET, "<$config{'cgipath'}$config{'alphabet'}") or print "Unable To Find File $config{'alphabet'}";
my @alphabet = <ALPHABET>;
close (ALPHABET);

my %letterkey;

$config{'keypad'} = "\
<table border=1>\
<TR>";

my $count = 0;
foreach my $line (@alphabet)
{
	my @letterkeys = split(/=/, $line);
	
	$letterkey{$letterkeys[0]} = $letterkeys[1];
	
	$config{'keypad'} .= "<TD><a href=\"".$config{'cgipath'}."script.cgi?&name=&letter=".$letterkeys[0]."&more\">".$letterkeys[1]."</a></TD>\n";
	
	$count++;
	if ($count == 20)
	{
		$config{'keypad'} .= "</tr><tr>\n";
		$count = 0;
	}
}

$config{'keypad'} .= "</TR>\
</TABLE>\
<table border=1>\
<TR><TD><a href=\"".$config{'cgipath'}."script.cgi?&name=&letter=erase&more\">Erase</a></TD></TR></TABLE><BR>\
Letter to insert: ";

sub set_alphabet
{
	return %letterkey;
}

sub set_config
{
	return %config;
}

sub oops 
{
	print "<HTML><HEAD><TITLE>ERROR</TITLE></HEAD><BODY>";
	print "<P><HR SIZE=1 NOSHADE><FONT COLOR=#FF0000><B>Error:</B></FONT><BR>$_[0]<P>Please hit the back browser on your browser to try again or contact the website administrator if you belive this to be a server problem.<HR SIZE=1 NOSHADE>\n";
	die "Error: $_[0]\n";
}