#!/usr/bin/perl

use CGI;
use strict;

require "config.pl";
my %letterkey = &set_alphabet;
my %config = &set_config;

my $q = new CGI;

my $page = $q->param("page");

print "Content-type: text/html\n\n";

my $horz = $q->param("horz");
my $vert = $q->param("vert");
my $name = $q->param("name");
my $letter = $q->param("letter");
my $bv = $q->param("bv");
my $bh = $q->param("bh");
my $pass = $q->param("pass");
my $passed = $q->param("passed");
my $abt = $q->param("abt");

my $letterval = $letterkey{$letter};

my $replaceval = "&page=grid&horz=$horz&vert=$vert&abt=$abt&passed=1";

$config{'keypad'} =~ s/\&more/$replaceval/gi;
$config{'keypad'} =~ s/name\=/name\=$name/gi;
$config{'keypad'} =~ s/script.cgi/maker.cgi/gi;

# Read and show the template header
my @footer;
if ($config{'template'})
{
	open (TPL, "<$config{'template'}") or print "Unable To Find Page $config{'template'}";
	my @template = <TPL>;
	close (TPL);
	
	my $insert = 0;
	foreach my $line (@template)
	{
		if ($line =~ "\@insert")
		{
			$insert = 1;
		}
		else
		{
			print $line unless (($insert) || ($line =~ "\@insert"));
			$footer[$insert-1] = $line if ($insert);
			$insert++ if ($insert);
		}
	}
}

# Show beginning page if no page is set
if(!$page)
{
	my $askpass = "";
	$askpass = "<TR><TD>Administrative Password: </TD><TD><input name=\"pass\" type=password></TD></TR>" if ($config{'password'});
	print << "END";
<form action="$config{'cgipath'}maker.cgi" method=post>
<table border=1>
<TR><TD>
<table border=0>
<TR><TD>Enter a name for this crossword: </TD><TD><input name="name" type=text></TD></TR>
<TR><TD>Horizontal Squares: </TD><TD><input name="horz" type=text size=5></TD></TR>
<TR><TD>Vertical Squares: </TD><TD><input name="vert" type=text size=5></TD></TR>
$askpass
</table>
<input type=hidden name=page value="grid">
<div align=right><input type=submit value="Begin!"></div>
</TD></TR></TABLE>
END
}
elsif ($page eq "grid") # Show page for setting up letters in grid
{
	# Check Password
	if ($config{'password'})
	{
		$pass = $config{'password'} if ($passed);
		unless ($pass eq $config{'password'})
		{
			print "ERROR!  Password Incorrect!<BR>Press the BACK button on your browser and try again!";
			die;
		}
	}
	
	# Create and update grid data file as needed	
	if (-e "$config{'docpath'}$name.gcw")
	{
 		if ($letter && ($bv ne "") && ($bh ne ""))
 		{
 			open (CWFILE, "<$config{'docpath'}$name.gcw");
 			my @cdata = <CWFILE>;
 			close (CWFILE);	
 			
 			open (CWFILE, ">$config{'docpath'}$name.gcw");
 			
 			my $count = 0;
 			
 			foreach my $line (@cdata)
 			{
 				my @spaces = split(/\|/, $line);
 				for (my $h = 0; $h < $horz; $h++)
 				{
 					if ($count == $bv && $h == $bh)
 					{
	 					$letter = "" if ($letter eq "erase");
 						$spaces[$h] = $letter;
 						$letter = "";
 					}
 					print CWFILE "$spaces[$h]|";
 				}
 				print CWFILE "\n";
 				$count++;
 			}
 			close (CWFILE);
 		}
	}
	else
	{
		print "Error: $!<BR>$config{'docpath'}$name.gcw" unless (open (CWFILE, ">$config{'docpath'}$name.gcw"));
		for (my $v = 1; $v <= $vert; $v++)
		{
			for (my $h = 1; $h <= $horz; $h++)
			{
				print CWFILE "|";
			}
			print CWFILE "\n"
		}
		close (CWFILE);
	}
	
	print $config{'keypad'};
	
	print "$letterval<BR>" if (($letter) && ($letter ne "erase"));
	print "Erase" if ($letter eq "erase");
	print "None<BR>" unless ($letter);
	
	# Read from Grid Data File
	open (CWFILE, "<$config{'docpath'}$name.gcw");
	my @cdata = <CWFILE>;
	close (CWFILE);	
	
	print "<table border=1>";
	
	# Display grid and all data that has been entered.
	my $v = 0;
	foreach my $line (@cdata)
	{
		print "<TR>";
		for (my $h = 0; $h < $horz; $h++)
		{
			print "<TD width=35 height=35>";
			
			my @spaces = split(/\|/, $line);
			
			if ($spaces[$h])
			{
				$letterval = $letterkey{$spaces[$h]};
				print "<center><a href=\"".$config{'cgipath'}."maker.cgi?page=grid&name=$name&horz=$horz&vert=$vert&bv=$v&bh=$h&horz=$horz&vert=$vert&letter=$letter&passed=1\">$letterval</a></center></TD>" if ($letter eq "erase");
				print "<center>$letterval</center></TD>" if ($letter ne "erase");
			}
			else
			{
				if (($letter) && ($letter ne "erase"))
				{
					print "<a href=\"".$config{'cgipath'}."maker.cgi?page=grid&name=$name&horz=$horz&vert=$vert&bv=$v&bh=$h&horz=$horz&vert=$vert&letter=$letter&passed=1\" STYLE=\"text-decoration: none\"><img src=\"".$config{'docpath'}."spacer.gif\" width=35 height=35 border=0></a></TD>";	
				}
				else
				{
					print "<img src=\"".$config{'docpath'}."spacer.gif\" width=35 height=35></TD>";
				}
			}
		}
		$v++;
		print "</TR>";
	}
	print "</table><BR><BR><a href=\"".$config{'cgipath'}."maker.cgi?page=hints&name=$name\">Next</a>";
}
elsif ($page eq "hints") # Show the page to allow people to enter in hints
{
	# Read the data file	
	open (CWFILE, "<$config{'docpath'}$name.gcw");
	my @cdata = <CWFILE>;
	close (CWFILE);	
	
	$vert = @cdata;
	
	my @grid;
	
	print "<table border=1>";
	
	# Sort the grid data into a 2 dimensional array
	my $v = 0;
	foreach my $line (@cdata)
	{
		my @spaces = split(/\|/, $line);
		$horz = @spaces;
		$horz--;
		
		$grid[$v] = \@spaces;
		
		$v++;
	}
	
	my $hcount = 0;
	my $vcount = 0;
	
	my @horzwords;
	my @vertwords;
	
	# Determine the location and number of each word.
	for ($v = 0; $v < $vert; $v++)
	{
		for (my $h = 0; $h < $horz; $h++)
		{
			if ($grid[$v][$h])
			{
				my $before = $grid[$v][$h-1];
				$before =~ s/\n//gi;
				$before =~ s/\r//gi;
				$before = "" if ($h == 0);
				if (($grid[$v][$h+1]) && (!$before))
				{
					$horzwords[$hcount] = "$v-$h";
					$hcount++;
				}
				$before = $grid[$v-1][$h];
				$before =~ s/\n//gi;
				$before =~ s/\r//gi;
				$before = "" if ($v == 0);
				if (($grid[$v+1][$h]) && (!$before))
				{
					$vertwords[$vcount] = "$v-$h";
					$vcount++;
				}
			}
		}
	}
	
	# Display the grid along with the words and numbers.
	for ($v = 0; $v < $vert; $v++)
	{		
 		print "<TR>";
 		for (my $h = 0; $h < $horz; $h++)
 		{
 			if ($grid[$v][$h])
 			{
 				print "<TD width=35 height=35>";
 				
 				my $count = 1;
 				my $found = 0;
 				foreach my $intersection (@vertwords)
 				{
	 				my @coordinates = split (/-/, $intersection);
	 				if (($coordinates[0] == $v) && ($coordinates[1] == $h))
	 				{
	 					print "<table border=0 width=\"100%\"><TR><TD colspan=2 bgcolor=\"#CCCCCC\"><center><font size=-2>$count</font></center></TD></TR>";
	 					$found++;
 					}
	 				$count++;
 				}
 				
 				$count = 1;
 				my $found2 = 0;
 				foreach my $intersection (@horzwords)
 				{
	 				my @coordinates = split (/-/, $intersection);
	 				if (($coordinates[0] == $v) && ($coordinates[1] == $h))
	 				{
		 				if ($found)
		 				{
	 						print "<TR><TD width=5 bgcolor=\"#CCCCCC\" height=1><font size=-2>$count</font></TD><TD>\n";	 				
		 				}
		 				else
		 				{
	 						print "<table border=0 width=\"100%\"><TR><TD colspan=2></TD></TR>\n";
	 						print "<TR><TD width=5 bgcolor=\"#CCCCCC\" height=1><font size=-2>$count</font></TD><TD>\n";
 						}
 						$found2++;
 					}
	 				$count++;
 				}
 				
 				print "<TR><TD width=10></TD><TD>\n" if (($found) && (!$found2));
 				
 				$letterval = $letterkey{$grid[$v][$h]};
 				print "<center>" unless ($found);
 				print "$letterval</center></TD>\n";
 				
 				if (($found) || ($found2))
 				{
	 				print "</TR></TABLE></TD>";
 				}
 			}
 			else
 			{
 				print "<TD width=35 height=35 bgcolor=\"000000\">";
				print "<img src=\"".$config{'docpath'}."spacer.gif\" width=35 height=35></TD>";
 			}
 		}
		print "</TR>";
	}
	
	print "</table><BR><BR>\n";
	
	# Display the Hints entry form
	print "<h3>Hints</h3>\n";
	print "<form action=\"".$config{'cgipath'}."maker.cgi\" method=post>\n";
	print "<table border=0 cellspacing=10><TR><TD valign=top><B>Horizontal</B><BR>\n";
	for (my $i = 1; $i <= $hcount; $i++)
	{
		print "#$i: <input type=text name=h$i><BR>";
	}
	
	print "</TD><TD valign=top><B>Vertical</B><BR>";
	for (my $i = 1; $i <= $vcount; $i++)
	{
		print "#$i: <input type=text name=v$i><BR>";
	}
	
	print "</TD></TR></TABLE>";
#	print "</table><BR><BR>\n";
	print "<input type=hidden name=hcount value=$hcount><input type=hidden name=vcount value=$vcount>\n";
	print "<input type=hidden name=page value=generate><input type=hidden name=name value=$name><input type=submit value=\"Generate Crossword\"></form>";
}
elsif ($page eq "generate") # Create hints file
{
	my $hcount = $q->param("hcount");
	my $vcount = $q->param("vcount");
	
	my @hintlines;
	
	for (my $i = 1; $i <= $hcount; $i++)
	{
		$hintlines[$i] = "$hintlines[$i]".$q->param("h$i");
	} 
	for (my $i = 1; $i <= $vcount; $i++)
	{
		$hintlines[$i] = "$hintlines[$i]|".$q->param("v$i");
	}
	
	my $larger = $hcount;
	if ($vcount > $hcount)
	{
		$larger = $vcount;
	} 
	
	open (HINTFILE, ">$config{'docpath'}$name.hnt") or print "Error!";
	for (my $i = 1; $i <= $larger; $i++)
	{
		print HINTFILE "$hintlines[$i]\n";
	}
	close (HINTFILE);
	print "Your crossword has been created.<BR><BR>You may view it <a href=".$config{'cgipath'}."viewer.cgi?name=$name>here</a>"
}

# Show the template footer
if ($config{'template'})
{	
	foreach my $line (@footer)
	{
		print $line;
	}
}