#!/usr/bin/perl

use CGI;
use strict;

require "config.pl";
my %letterkey = &set_alphabet;
my %config = &set_config;

my $q = new CGI;

my $page = $q->param("page");

print "Content-type: text/html\n\n";

my $name = $q->param("name");
my $letter = $q->param("letter");
my $bv = $q->param("bv");
my $bh = $q->param("bh");

my $letterval = $letterkey{$letter};

$config{'keypad'} =~ s/\&more//gi;
$config{'keypad'} =~ s/name\=/name\=$name/gi;
$config{'keypad'} =~ s/script.cgi/viewer.cgi/gi;

# Read and show the template header
my @footer;
if ($config{'template'})
{
	open (TPL, "<$config{'template'}") or &oops("Unable To Find Page $config{'template'}");
	my @template = <TPL>;
	close (TPL);
	
	my $insert = 0;
	foreach my $line (@template)
	{
		if ($line =~ "\@insert")
		{
			$insert = 1;
		}
		else
		{
			print $line unless (($insert) || ($line =~ "\@insert"));
			$footer[$insert-1] = $line if ($insert);
			$insert++ if ($insert);
		}
	}
}

my $horz;
my $vert;

# Open the grid data file
open (CWFILE, "<$config{'docpath'}$name.gcw") or &oops("Unable To Open File $name.gcw");
my @cdata = <CWFILE>;
close (CWFILE);	

unless ($page eq "answers")
{
	print $config{'keypad'};
	
	print "$letterval<BR>" if (($letter) && ($letter ne "erase") && ($bv eq ""));
	print "Erase" if ($letter eq "erase");
	print "None<BR>" unless ($letter);
}
	
$vert = @cdata;

my @grid;
	
print "<table border=1>";
	
# Bring the grid data into a 2 dimensional array
my $v = 0;
foreach my $line (@cdata)
{
	my @spaces = split(/\|/, $line);
	$horz = @spaces;
	$horz--;
	
	$grid[$v] = \@spaces;
	
	$v++;
}

# Create answer tracking file and update as necessary
if (-e "$config{'docpath'}/temp/$name$ENV{REMOTE_ADDR}.ans")
{
	if ($letter && ($bv ne "") && ($bh ne ""))
	{
		open (CWFILE, "<$config{'docpath'}/temp/$name$ENV{REMOTE_ADDR}.ans");
		my @cdata = <CWFILE>;
		close (CWFILE);	
			
		open (CWFILE, ">$config{'docpath'}/temp/$name$ENV{REMOTE_ADDR}.ans");
			
		my $count = 0;
		
		foreach my $line (@cdata)
		{
			my @spaces = split(/\|/, $line);
			for (my $h = 0; $h < $horz; $h++)
			{
				if ($count == $bv && $h == $bh)
				{
					$letter = "" if ($letter eq "erase");
					$spaces[$h] = $letter;
					$letter = "";
				}
				print CWFILE "$spaces[$h]|";
			}
			print CWFILE "\n";
			$count++;
		}
		close (CWFILE);
	}
}
else
{
	print "Error: $!<BR>$config{'docpath'}/temp/$name$ENV{REMOTE_ADDR}.ans" unless (open (CWFILE, ">$config{'docpath'}/temp/$name$ENV{REMOTE_ADDR}.ans"));
	for (my $v = 1; $v <= $vert; $v++)
	{
		for (my $h = 1; $h <= $horz; $h++)
		{
			print CWFILE "|";
		}
		print CWFILE "\n"
	}
	close (CWFILE);
}

# Read the answer grid file and put it into a 2 dimensional array
open (ANSFILE, "<$config{'docpath'}/temp/$name$ENV{REMOTE_ADDR}.ans");
my @ansdata = <ANSFILE>;
close (ANSFILE);

my @ansgrid;

my $acount = 0;
foreach my $line (@ansdata)
{
	my @spaces = split(/\|/, $line);
	
	$ansgrid[$acount] = \@spaces;
	
	$acount++;
}	


my $hcount = 0;
my $vcount = 0;

my @horzwords;
my @vertwords;

# Locate and number each word
for ($v = 0; $v < $vert; $v++)
{
	for (my $h = 0; $h < $horz; $h++)
	{
		if ($grid[$v][$h])
		{
			my $before = $grid[$v][$h-1];
			$before =~ s/\n//gi;
			$before =~ s/\n//gi;
			$before =~ s/\r//gi;
			$before = "" if ($h == 0);
			if (($grid[$v][$h+1]) && (!$before))
			{
				$horzwords[$hcount] = "$v-$h";
				$hcount++;
			}
			$before = $grid[$v-1][$h];
			$before =~ s/\n//gi;
			$before =~ s/\r//gi;
			$before = "" if ($v == 0);
			if (($grid[$v+1][$h]) && (!$before))
			{
				$vertwords[$vcount] = "$v-$h";
				$vcount++;
			}
		}
	}
}

# Display the grid and the answers given
for ($v = 0; $v < $vert; $v++)
{		
	print "<TR>";
	for (my $h = 0; $h < $horz; $h++)
	{
		if ($grid[$v][$h])
		{
			print "<TD width=35 height=35>";
			
			my $count = 1;
			my $found = 0;
			foreach my $intersection (@vertwords)
			{
 				my @coordinates = split (/-/, $intersection);
 				if (($coordinates[0] == $v) && ($coordinates[1] == $h))
 				{
 					print "<table border=0 width=\"100%\"><TR><TD colspan=2 bgcolor=\"#CCCCCC\"><center><font size=-2>$count</font></center></TD></TR>";
 					$found++;
				}
 				$count++;
			}
 				
			$count = 1;
			my $found2 = 0;
			foreach my $intersection (@horzwords)
			{
				my @coordinates = split (/-/, $intersection);
 				if (($coordinates[0] == $v) && ($coordinates[1] == $h))
 				{
	 				if ($found)
	 				{
 						print "<TR><TD width=5 bgcolor=\"#CCCCCC\" height=1><font size=-2>$count</font></TD><TD>\n";	 				
	 				}
	 				else
	 				{
 						print "<table border=0 width=\"100%\"><TR><TD colspan=2></TD></TR>\n";
 						print "<TR><TD width=5 bgcolor=\"#CCCCCC\" height=1><font size=-2>$count</font></TD><TD>\n";
 					}
					$found2++;
				}
 				$count++;
			}
 				
			print "<TR><TD width=10></TD><TD>\n" if (($found) && (!$found2));
 				
			print "<center>" unless ($found);
			
			if ($ansgrid[$v][$h])
			{
				$letterval = $letterkey{$ansgrid[$v][$h]};
				print "<a href=\"".$config{'cgipath'}."viewer.cgi?name=$name&bv=$v&bh=$h&letter=$letter\">$letterval</a></center></td>\n" if ($letter eq "erase");
				print "$letterval</center></td>\n" if ($letter ne "erase");
			}
			else
			{
				if (($letter) && ($letter ne "erase"))
				{
					print "<a href=\"".$config{'cgipath'}."viewer.cgi?name=$name&bv=$v&bh=$h&letter=$letter\" STYLE=\"text-decoration: none\"><img src=\"".$config{'docpath'}."spacer.gif\" width=20 height=20 border=0></a></center></TD>";	
				}
				else
				{
 					print "<img src=\"".$config{'docpath'}."spacer.gif\" width=20 height=20></center></td>\n";
 				}
			}					
			if (($found) || ($found2))
			{
				print "</TR></TABLE></TD>";
			}
		}
		else
		{
			print "<TD width=35 height=35 bgcolor=\"000000\">";
			print "<img src=\"".$config{'docpath'}."spacer.gif\" width=35 height=35></TD>";
 		}
 	}
	print "</TR>";
}

if ($page eq "answers")
{
	# Determine what each of the horizontal words are
	my @hword;
	for (my $i = 0; $i < $hcount; $i++)
	{
		my @xy = split(/-/, $horzwords[$i]);
		my $hnow = $xy[1];
		my $vnow = $xy[0];
		while (($grid[$vnow][$hnow]) && ($grid[$vnow][$hnow] ne "\n") && ($grid[$vnow][$hnow] ne "\r\n"))
		{
			$letterval = $letterkey{$grid[$vnow][$hnow]};
			$hword[$i+1] = "$hword[$i+1]$letterval";
			$hnow++;
		}
	}
	
	# Determine what each of the verticle words are
	my @vword;
	for (my $i = 0; $i < $vcount; $i++)
	{
		my @xy = split(/-/, $vertwords[$i]);
		my $hnow = $xy[1];
		my $vnow = $xy[0];
		while (($grid[$vnow][$hnow]) && ($grid[$vnow][$hnow] ne "\n") && ($grid[$vnow][$hnow] ne "\r\n"))
		{
			$letterval = $letterkey{$grid[$vnow][$hnow]};
			$vword[$i+1] = "$vword[$i+1]$letterval";
			$vnow++;
		}
	}
	
	# Read and show the hints + answers for the crossword	
	open (HINTFILE, "<$config{'docpath'}$name.hnt");
	my @hdata = <HINTFILE>;
	close (HINTFILE);
	
	my @hints;
	my $hintcount = 1;
	
	foreach my $hline (@hdata)
	{
		$hints[$hintcount] = $hline;
		$hintcount++;
	}	
	
	print "</table><BR><BR>";
	print "<B>Answers</B><BR>";
	print "<table border=0 cellspacing=10><TR><TD valign=top><B>Horizontal</B><BR>";
	for (my $i = 1; $i <= $hcount; $i++)
	{
		my @hintsplit = split(/\|/, $hints[$i]);
		print "<table border=1 width=100%><TR><TD>$i. $hintsplit[0]<BR>";
		print "Answer: $hword[$i]</TD></TR></TABLE>";
	}

	print "</TD><TD valign=top><B>Vertical</B><BR>";
	for (my $i = 1; $i <= $vcount; $i++)
	{
		my @hintsplit = split(/\|/, $hints[$i]);
		print "<table border=1 width=100%><TR><TD>$i. $hintsplit[1]<BR>";
		print "Answer: $vword[$i]</TD></TR></TABLE>";
	}

	print "</TD></TR></TABLE>";	
	
	my $ansfilename = "$config{'docpath'}/temp/$name$ENV{REMOTE_ADDR}.ans";
	unlink ($ansfilename);
}
else
{
	# Read and show the hints for the crossword	
	open (HINTFILE, "<$config{'docpath'}$name.hnt") or &oops("Unable To Open File $name.hnt");
	my @hdata = <HINTFILE>;
	close (HINTFILE);
	
	my @hints;
	my $hintcount = 1;
	
	foreach my $hline (@hdata)
	{
		$hints[$hintcount] = $hline;
		$hintcount++;
	}	
	
	print "</table><BR><BR>";
	print "<B>Hints</B><BR>";
	print "<table border=0 cellspacing=10><TR><TD valign=top><B>Horizontal</B><BR>";
	for (my $i = 1; $i <= $hcount; $i++)
	{
		my @hintsplit = split(/\|/, $hints[$i]);
		print "$i. $hintsplit[0]<BR>";
	}

	print "</TD><TD valign=top><B>Vertical</B><BR>";
	for (my $i = 1; $i <= $vcount; $i++)
	{
		my @hintsplit = split(/\|/, $hints[$i]);
		print "$i. $hintsplit[1]<BR>";
	}

	print "</TD></TR></TABLE>";
	print "<a href=".$config{'cgipath'}."viewer.cgi?name=$name&page=answers>Show Answers!</a>";
}

# Show the template footer
if ($config{'template'})
{	
	foreach my $line (@footer)
	{
		print $line;
	}
}